local nkRebuffInfo, nkRebuff = ...

function nkRebuff.buildBars ()

	if nkRebuff.privateVars.performance.warning == true then
		if nkRebuff.UIelements.warningBar == nil then 
			nkRebuff.UIelements.warningBar = nkRebuff.abilityBar:new(nkRebuff.const.barWarningsID, { movelabel = nkRebuff.langTexts.abilityBars.barLabelWarning, xpos = nkRBSetup.bars[nkRebuff.const.barWarningsID].xpos, ypos = nkRBSetup.bars[nkRebuff.const.barWarningsID].ypos, moveFunc = function (xpos, ypos) nkRBSetup.bars[nkRebuff.const.barWarningsID].xpos = xpos; nkRBSetup.bars[nkRebuff.const.barWarningsID].ypos = ypos; nkRebuff.UIelements.warningBar:setCoords(xpos, ypos) end }) 
		else 
			for k, v in pairs (nkRebuff.UIelements.warningBar.icons) do v:SetVisible(false) end
			nkRebuff.UIelements.warningBar:SetVisible(true)
		end
	end

	if nkRebuff.privateVars.performance.buffs == true then
		if nkRebuff.UIelements.buffBar == nil then 
			nkRebuff.UIelements.buffBar = nkRebuff.abilityBar:new(nkRebuff.const.barBuffsID, { movelabel = nkRebuff.langTexts.abilityBars.barLabelBuffs, xpos = nkRBSetup.bars[nkRebuff.const.barBuffsID].xpos, ypos = nkRBSetup.bars[nkRebuff.const.barBuffsID].ypos, moveFunc = function (xpos, ypos) nkRBSetup.bars[nkRebuff.const.barBuffsID].xpos = xpos; nkRBSetup.bars[nkRebuff.const.barBuffsID].ypos = ypos; nkRebuff.UIelements.buffBar:setCoords(xpos, ypos) end }) 
		else 
			for k, v in pairs (nkRebuff.UIelements.buffBar.icons) do v:SetVisible(false) end
			nkRebuff.UIelements.buffBar:SetVisible(true)
		end
	end
	
	if nkRebuff.privateVars.performance.debuffs == true then
		if nkRebuff.UIelements.debuffBar == nil then 
			nkRebuff.UIelements.debuffBar = nkRebuff.abilityBar:new(nkRebuff.const.barDebuffsID, { movelabel = nkRebuff.langTexts.abilityBars.barLabelDebuffs, xpos = nkRBSetup.bars[nkRebuff.const.barDebuffsID].xpos, ypos = nkRBSetup.bars[nkRebuff.const.barDebuffsID].ypos, moveFunc = function (xpos, ypos) nkRBSetup.bars[nkRebuff.const.barDebuffsID].xpos = xpos; nkRBSetup.bars[nkRebuff.const.barDebuffsID].ypos = ypos; nkRebuff.UIelements.debuffBar:setCoords(xpos, ypos) end })
		else
			for k, v in pairs (nkRebuff.UIelements.debuffBar.icons) do v:SetVisible(false) end
			nkRebuff.UIelements.debuffBar:SetVisible(true)
		end
	end
	
	if nkRebuff.privateVars.performance.cooldowns == true then
		if nkRebuff.UIelements.cooldownBar == nil then 
			nkRebuff.UIelements.cooldownBar = nkRebuff.abilityBar:new(nkRebuff.const.barCooldownsID, { movelabel = nkRebuff.langTexts.abilityBars.barLabelCooldowns, xpos = nkRBSetup.bars[nkRebuff.const.barCooldownsID].xpos, ypos = nkRBSetup.bars[nkRebuff.const.barCooldownsID].ypos, moveFunc = function (xpos, ypos) nkRBSetup.bars[nkRebuff.const.barCooldownsID].xpos = xpos; nkRBSetup.bars[nkRebuff.const.barCooldownsID].ypos = ypos; nkRebuff.UIelements.cooldownBar:setCoords(xpos, ypos) end })
		else
			for k, v in pairs (nkRebuff.UIelements.cooldownBar.icons) do v:SetVisible(false) end
			nkRebuff.UIelements.cooldownBar:SetVisible(true)
		end
	
		if nkRebuff.UIelements.activeBar == nil then
			nkRebuff.UIelements.activeBar = nkRebuff.abilityBar:new(nkRebuff.const.barAbilitiesID, { movelabel = nkRebuff.langTexts.abilityBars.barLabelActive, xpos = nkRBSetup.bars[nkRebuff.const.barAbilitiesID].xpos, ypos = nkRBSetup.bars[nkRebuff.const.barAbilitiesID].ypos, moveFunc = function (xpos, ypos) nkRBSetup.bars[nkRebuff.const.barAbilitiesID].xpos = xpos; nkRBSetup.bars[nkRebuff.const.barAbilitiesID].ypos = ypos; nkRebuff.UIelements.activeBar:setCoords(xpos, ypos) end })
		else
			for k, v in pairs (nkRebuff.UIelements.activeBar.icons) do v:SetVisible(false) end
			nkRebuff.UIelements.activeBar:SetVisible(true)
		end
	end

	if nkRebuff.privateVars.performance.debuffsPlayer == true then
		if nkRebuff.UIelements.debuffPlayerBar == nil then 
			nkRebuff.UIelements.debuffPlayerBar = nkRebuff.abilityBar:new(nkRebuff.const.barDebuffsPlayerID, { movelabel = nkRebuff.langTexts.abilityBars.barLabelDebuffsPlayer, xpos = nkRBSetup.bars[nkRebuff.const.barDebuffsPlayerID].xpos, ypos = nkRBSetup.bars[nkRebuff.const.barDebuffsPlayerID].ypos, moveFunc = function (xpos, ypos) nkRBSetup.bars[nkRebuff.const.barDebuffsPlayerID].xpos = xpos; nkRBSetup.bars[nkRebuff.const.barDebuffsPlayerID].ypos = ypos; nkRebuff.UIelements.debuffPlayerBar:setCoords(xpos, ypos) end })
		else 
			for k, v in pairs (nkRebuff.UIelements.debuffPlayerBar.icons) do v:SetVisible(false) end
			nkRebuff.UIelements.debuffPlayerBar:SetVisible(true)
		end
	end
	
	if nkRebuff.privateVars.performance.buffTarget == true then
		if nkRebuff.UIelements.buffTargetBar == nil then 
			nkRebuff.UIelements.buffTargetBar = nkRebuff.abilityBar:new(nkRebuff.const.barbuffTargetID, { movelabel = nkRebuff.langTexts.abilityBars.barLabelBuffsPlayer, xpos = nkRBSetup.bars[nkRebuff.const.barbuffTargetID].xpos, ypos = nkRBSetup.bars[nkRebuff.const.barbuffTargetID].ypos, moveFunc = function (xpos, ypos) nkRBSetup.bars[nkRebuff.const.barbuffTargetID].xpos = xpos; nkRBSetup.bars[nkRebuff.const.barbuffTargetID].ypos = ypos; nkRebuff.UIelements.buffTargetBar:setCoords(xpos, ypos) end })
		else 
			for k, v in pairs (nkRebuff.UIelements.buffTargetBar.icons) do v:SetVisible(false) end
			nkRebuff.UIelements.buffTargetBar:SetVisible(true)
		end
	end

	
end

function nkRebuff.updateBars()
	
	if nkRebuff.UIelements.warningBar ~= nil then nkRebuff.UIelements.warningBar:Update() end 
	if nkRebuff.UIelements.buffBar ~= nil then nkRebuff.UIelements.buffBar:Update() end 
	if nkRebuff.UIelements.debuffBar ~= nil then nkRebuff.UIelements.debuffBar:Update() end 
	if nkRebuff.UIelements.debuffPlayerBar ~= nil then nkRebuff.UIelements.debuffPlayerBar:Update() end 
	if nkRebuff.UIelements.cooldownBar ~= nil then nkRebuff.UIelements.cooldownBar:Update() end 
	if nkRebuff.UIelements.activeBar ~= nil then nkRebuff.UIelements.activeBar:Update() end 
end

function nkRebuff.hideAllBars ()

	if nkRebuff.UIelements.warningBar ~= nil then nkRebuff.UIelements.warningBar:SetVisible(false) end
	if nkRebuff.UIelements.buffBar ~= nil then nkRebuff.UIelements.buffBar:SetVisible(false) end
	if nkRebuff.UIelements.debuffBar ~= nil then nkRebuff.UIelements.debuffBar:SetVisible(false) end
	if nkRebuff.UIelements.debuffPlayerBar ~= nil then nkRebuff.UIelements.debuffPlayerBar:SetVisible(false) end
	if nkRebuff.UIelements.cooldownBar ~= nil then nkRebuff.UIelements.cooldownBar:SetVisible(false) end
	if nkRebuff.UIelements.activeBar ~= nil then nkRebuff.UIelements.activeBar:SetVisible(false) end

end

nkRebuff.events = {}


function nkRebuff.events.updateHandler()
	
	if nkRebuff.UIelements.tooltip ~= nil and nkRebuff.privateVars.tooltipShowTime ~= nil then
		local tmpTime = Inspect.Time.Real()
		if nkTools.math.round((tmpTime - nkRebuff.privateVars.tooltipShowTime), 1) > 5 then nkRebuff.hideTooltip() end
	end
	
	if nkRBSetup.basic.active == false and nkRebuff.privateVars.barsLocked == true then return end
	
	if nkRebuff.privateVars.barsLocked == false or nkRBSetup.basic.combatOnly == false or Inspect.System.Secure() == true or (nkRebuff.UIelements.configUI ~= nil and nkRebuff.UIelements.configUI.frame:isVisible() == true and nkRBSetup.basic.showBarsDuringConfig == true ) then
		if nkRebuff.privateVars.forceUpdate ~= true then
			if nkRebuff.privateVars.lastBarUpdate == nil then
				nkRebuff.privateVars.lastBarUpdate = Inspect.Time.Real()
				nkRebuff.privateVars.forceUpdate = true
			else
				local tmpTime = Inspect.Time.Real()
				if nkTools.math.round((tmpTime - nkRebuff.privateVars.lastBarUpdate), 1) > nkRBSetup.basic.throttle then nkRebuff.privateVars.forceUpdate = true end
			end
		end
		
		if nkRebuff.privateVars.forceUpdate then					
		
			if nkRebuff.UIelements.configUI ~= nil and nkRebuff.UIelements.configUI.frame:isVisible() == true and nkRBSetup.basic.showBarsDuringConfig == true then nkRebuff.updateBars() end
		
			-- nkRebuff.privateVars.mainLog:logPerformance ('overall')
			
			-- nkRebuff.privateVars.mainLog:logMessage ('updateHandler start', nkLog.levelInfo)
		
			nkRebuff.privateVars.lastBarUpdate = Inspect.Time.Real()
			nkRebuff.privateVars.forceUpdate = false
			nkRebuff.privateVars.warnItems = { items = {}, warningCount = 0}
						
			-- nkRebuff.privateVars.mainLog:logPerformance ('build bars')
						
			nkRebuff.buildBars()
			
			-- nkRebuff.privateVars.mainLog:logPerformance ('build bars')

			nkRebuff.privateVars.tempData = {	buffs = { active = {}, missingCount = 0, nearRunoutList = {}, missing = {} }, 
												debuffs = { active = {}, warnAboutCount = 0, warnAbout = {} },
												ability = { active = {}, relevantCount = 0, relevant = {}  },												
											}
			
			if nkRebuff.privateVars.performance.buffs == true or nkRebuff.privateVars.performance.debuffsPlayer == true or nkRebuff.privateVars.performance.cooldowns == true then					
			
				-- nkRebuff.privateVars.mainLog:logMessage ('get buff list', nkLog.levelInfo)
			
				local bufflist = Inspect.Buff.List("player")
				if bufflist then
					-- get all relevant data
					
					-- nkRebuff.privateVars.mainLog:logMessage ('get all relevant data', nkLog.levelInfo)
				
					local buffDetails = Inspect.Buff.Detail("player", bufflist)
					for k, buff in pairs(buffDetails) do
						if nkRebuff.privateVars.performance.buffs == true and (buff.curse ~= true and buff.debuff ~= true) then
							nkRebuff.privateVars.tempData.buffs.active[buff.name] = buff
						elseif nkRebuff.privateVars.performance.debuffsPlayer == true and (buff.curse == true or buff.debuff == true) then
							nkRebuff.privateVars.tempData.debuffs.active[buff.name] = buff
							
							if nkRebuff.privateVars.lastDebuffs[buff.name .. buff.caster] == nil then							
								nkRebuff.privateVars.lastDebuffs[buff.name .. buff.caster] = buff
								
								local casterDetails = Inspect.Unit.Detail(buff.caster)
								if casterDetails ~= nil then nkRebuff.privateVars.lastDebuffs[buff.name .. buff.caster].casterDetails = casterDetails end
							end
						end
						
						if nkRebuff.privateVars.performance.cooldowns == true and buff.abilityNew ~= nil then
							local details = Inspect.Ability.New.Detail(buff.abilityNew)
							if details ~= nil then
								local name = string.gsub (details.name, '\n', ' ')
								nkRebuff.privateVars.tempData.ability.active[name] = buff
							end
						end
						
					end
					
					
					if nkRebuff.privateVars.performance.buffs == true then
						-- check for missing buffs by player
						
						-- nkRebuff.privateVars.mainLog:logMessage ('check for missing buffs by player', nkLog.levelInfo)
												
						for name, buff in pairs (nkRBSetup.sets[nkRBSetup.basic.activeSet].buff) do
							nkRebuff.events.checkBuffsForMissing(buff, name, nkRBSetup.data.buff[name])
						end
													
						-- check for missing buffs by other players
						
						-- nkRebuff.privateVars.mainLog:logMessage ('check for missing buffs by other players', nkLog.levelInfo)
						
						for name, buff in pairs(nkRBSetup.sets[nkRBSetup.basic.activeSet].buff3rd) do
							nkRebuff.events.checkBuffsForMissing(buff, name, nkRBSetup.data.buff3rd[name])
						end
					end
					
					if nkRebuff.privateVars.performance.debuffsPlayer == true then
						-- check for debuffs on player
						
						-- nkRebuff.privateVars.mainLog:logMessage ('check for debuffs on player', nkLog.levelInfo)
					
						for name, debuff in pairs (nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff3rd) do
							if debuff.active == true and nkRebuff.privateVars.tempData.debuffs.active[name] ~= nil and nkRebuff.privateVars.tempHides.debuff3rd[name] ~= true then
								nkRebuff.privateVars.tempData.debuffs.warnAbout[name] = nkRebuff.privateVars.tempData.debuffs.active[name]
								nkRebuff.privateVars.tempData.debuffs.warnAboutCount = nkRebuff.privateVars.tempData.debuffs.warnAboutCount + 1
							end
						end
					end
					
					if nkRebuff.privateVars.performance.cooldowns == true then
						-- check for abilities to show
						
						-- nkRebuff.privateVars.mainLog:logMessage ('check for abilities to show', nkLog.levelInfo)
						
						for name, ability in pairs (nkRBSetup.sets[nkRBSetup.basic.activeSet].CD) do
							if ability.active == true and ability.nat ~= true and nkRebuff.privateVars.tempData.ability.active[name] ~= nil then
								nkRebuff.privateVars.tempData.ability.relevant[name] = nkRebuff.privateVars.tempData.ability.active[name]
								nkRebuff.privateVars.tempData.ability.relevantCount = nkRebuff.privateVars.tempData.ability.relevantCount + 1
							end
						end
					end
				end
				
				-- check player's pet buffs
				
				if nkRebuff.privateVars.performance.buffs == true then
				
					local bufflist = Inspect.Buff.List("player.pet")
				
					if bufflist then

						local buffDetails = Inspect.Buff.Detail("player.pet", bufflist)
						
						for k, buff in pairs(buffDetails) do
							 if (buff.curse ~= true and buff.debuff ~= true) then
								--print ('adding ' .. buff.name)
								nkRebuff.privateVars.tempData.buffs.active[buff.name] = buff
							end
						end					
						
						-- check for missing buffs by player's pet
													
						for name, buff in pairs (nkRBSetup.sets[nkRBSetup.basic.activeSet].buffPet) do

							--if nkRebuff.privateVars.tempData.buffs.active[name] == nil then
							--	print (name .. ' is nil')
							--else
							--	print (name .. ' is not nil')
							--end
							
							nkRebuff.events.checkBuffsForMissing(buff, name, nkRBSetup.data.buff[name])
						end
					end
				end
			end
			
			-- process buff result
			
			-- nkRebuff.privateVars.mainLog:logPerformance ('check 1')				
			
			-- nkRebuff.privateVars.mainLog:logMessage ('process buff result', nkLog.levelInfo)
			
			if nkRebuff.privateVars.performance.buffs == true and nkRebuff.privateVars.tempData.buffs.missingCount > 0  then 
				nkRebuff.processing.processBuffs (nkRebuff.privateVars.tempData.buffs.missing, nkRebuff.privateVars.tempData.buffs.nearRunoutList)
			else
				if nkRebuff.UIelements.buffBar ~= nil and nkRebuff.privateVars.barsLocked == true then nkRebuff.UIelements.buffBar:SetVisible(false) end
			end
			
			-- nkRebuff.privateVars.mainLog:logPerformance ('check 1')				
			-- nkRebuff.privateVars.mainLog:logPerformance ('check 2')				
			
			-- process debuff on player result

			-- nkRebuff.privateVars.mainLog:logMessage ('process debuff on player result', nkLog.levelInfo)
			
			if nkRebuff.privateVars.performance.debuffsPlayer == true and nkRebuff.privateVars.tempData.debuffs.warnAboutCount > 0 then 
				nkRebuff.processing.processDebuffsPlayer (nkRebuff.privateVars.tempData.debuffs.warnAbout) 
			else
				if nkRebuff.UIelements.debuffPlayerBar ~= nil and nkRebuff.privateVars.barsLocked == true then nkRebuff.UIelements.debuffPlayerBar:SetVisible(false) end
			end
			
			-- nkRebuff.privateVars.mainLog:logPerformance ('check 2')				
			-- nkRebuff.privateVars.mainLog:logPerformance ('check 3')				
			
			-- process debuff on target
			
			-- nkRebuff.privateVars.mainLog:logMessage ('process debuff on target', nkLog.levelInfo)
			
			if nkRebuff.privateVars.performance.debuffs == true then 
				for k, v in pairs(nkRebuff.UIelements.debuffBar.icons) do v:SetVisible(false) end
			else
				if nkRebuff.UIelements.debuffBar ~= nil and nkRebuff.privateVars.barsLocked == true then nkRebuff.UIelements.debuffBar:SetVisible(false) end
			end
			
			if nkRebuff.privateVars.performance.buffTarget == true then 
				for k, v in pairs(nkRebuff.UIelements.buffTargetBar.icons) do v:SetVisible(false) end
			else
				if nkRebuff.UIelements.buffTargetBar ~= nil and nkRebuff.privateVars.barsLocked == true then nkRebuff.UIelements.buffTargetBar:SetVisible(false) end
			end
			
			if nkRebuff.privateVars.performance.debuffs == true or nkRebuff.privateVars.performance.buffTarget == true then
				nkRebuff.processing.processTarget()
			end
			
			-- nkRebuff.privateVars.mainLog:logPerformance ('check 3')				
			-- nkRebuff.privateVars.mainLog:logPerformance ('check 4')				
			
			-- process cooldowns
			
			-- nkRebuff.privateVars.mainLog:logMessage ('process cooldowns', nkLog.levelInfo)
			
			if nkRebuff.privateVars.performance.cooldowns == true then
				nkRebuff.processing.processCooldowns()
			else
				if nkRebuff.UIelements.cooldownBar ~= nil and nkRebuff.privateVars.barsLocked == true then nkRebuff.UIelements.cooldownBar:SetVisible(false) end
			end
			
			-- nkRebuff.privateVars.mainLog:logPerformance ('check 4')				
			-- nkRebuff.privateVars.mainLog:logPerformance ('check 5')				
			
			-- process abilities result
			
			-- nkRebuff.privateVars.mainLog:logMessage ('process abilities result', nkLog.levelInfo)
			
			if nkRebuff.privateVars.performance.cooldowns == true and nkRebuff.privateVars.tempData.ability.relevantCount > 0 then
				nkRebuff.processing.processAbilities(nkRebuff.privateVars.tempData.ability.relevant)
			else
				if nkRebuff.UIelements.activeBar ~= nil and nkRebuff.privateVars.barsLocked == true then nkRebuff.UIelements.activeBar:SetVisible(false) end
			end
			
			if nkRebuff.privateVars.performance.warning == true and nkRebuff.privateVars.warnItems.warningCount > 0 then
				nkRebuff.processing.processWarnings()
			else
				if nkRebuff.UIelements.warningBar ~= nil and nkRebuff.privateVars.barsLocked == true then nkRebuff.UIelements.warningBar:SetVisible(false) end
			end
		
		
			-- nkRebuff.privateVars.mainLog:logPerformance ('check 5')
			-- nkRebuff.privateVars.mainLog:logPerformance ('overall')				
			-- nkRebuff.privateVars.mainLog:logMessage ('updateHandler end', nkLog.levelInfo)
			
		end					
	else
		nkRebuff.hideAllBars ()
	end
	
end

function nkRebuff.events.cooldownBegin (cooldowns)
	
	if nkRBSetup.basic.doRecognition == false then return end
	
	for ability, cd in pairs (cooldowns) do
		if cd > 1 then
			local abilityInfo = Inspect.Ability.New.Detail(ability)
			if abilityInfo ~= nil then 
				
				local name = string.gsub (abilityInfo.name, '\n', ' ')
				
				if nkRBSetup.data.CD[name] == nil then
					nkRBSetup.data.CD[name] = { ability = ability, icon = abilityInfo.icon, duration = 0, hidden = false }
					nkRebuff.addAbility('CD', name, false)
				end
			end
		end
	end
	
end

function nkRebuff.events.BuffAdd (unit, buffs)

	if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('Buff changed detected', nkLog.levelInfo) end

	if nkRBSetup.basic.doRecognition == false then 
		-- nkRebuff.privateVars.mainLog:logMessage ('detection turned off', nkLog.levelWarning)	
		return
	end
	
	unitDetails = Inspect.Unit.Detail (unit)
	playerDetails = nkRebuff.getUnitDetails ('player')
	petDetails = nkRebuff.getUnitDetails ('player.pet')	
	playerTarget = Inspect.Unit.Detail ('player.target')
	
	if playerTarget ~= nil then
		if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('unit name: ' .. unitDetails.name, nkLog.levelInfo)	end
		if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('target name: ' .. playerTarget.name, nkLog.levelInfo) end
	end
	
	if playerTarget ~= nil and unitDetails.name == playerTarget.name then
		if nkRBSetup.basic.debugAddon == true then  nkRebuff.privateVars.mainLog:logMessage ('change is related to player target', nkLog.levelInfo)	end
		buffDetails = Inspect.Buff.Detail('player.target', buffs)
		
		for k, buff in pairs (buffDetails) do
			local caster = buff.caster
			local casterDetails = Inspect.Unit.Detail(caster)

			if buff.debuff == true then
				nkRebuff.events.processDebuff(buff, casterDetails, playerDetails)
			else
				nkRebuff.events.processBuff(buff, casterDetails, playerDetails)
			end
		end
	elseif petDetails ~= nil and unitDetails.name == petDetails.name then
		if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('Buff is related to player\'s pet', nkLog.levelInfo) end
		buffDetails = Inspect.Buff.Detail('player.pet', buffs)
		
		for k, buff in pairs (buffDetails) do
			if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('found [' .. buff.name .. ']', nkLog.levelInfo) end
		
			local caster = buff.caster
			local casterDetails = Inspect.Unit.Detail(caster)			
	
			if buff.debuff == true or buff.curse == true then			
				if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('curse or debuff on player\'s pet', nkLog.levelInfo) end
				
				if nkRBSetup.basic.debuffWarning == true then nkRebuff.privateVars.forceUpdate = true end
			
				local debuffCaster = 'NPC'
				
				if casterDetails == nil then
					if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('caster details nil', nkLog.levelInfo)	end
				else
					if nkRBSetup.basic.debugAddon == true and casterDetails.player then nkRebuff.privateVars.mainLog:logMessage ('caster details player: ' .. casterDetails.calling, nkLog.levelInfo) end
				end
				
				if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('caster: ' .. debuffCaster, nkLog.levelInfo) end
								
				if casterDetails ~= nil and casterDetails.player == true then debuffCaster = casterDetails.calling end
				
				if nkRBSetup.data.debuff3rd[buff.name] == nil then
					nkRBSetup.data.debuff3rd[buff.name] = { caster = debuffCaster, ability = buff.abilityNew, icon = buff.icon, duration = buff.duration, hidden = false }
					nkRebuff.addAbility('debuff3rd', buff.name, nkRBSetup.basic.newDebuffActive)
				end
			elseif casterDetails ~= nil then -- Buffs wie Ausgeruht filtern
				if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('buff on player\'s pet', nkLog.levelInfo)	end
				nkRebuff.events.processBuff(buff, casterDetails, playerDetails)
			end
		end	
		
	elseif unitDetails.name == playerDetails.name then
	
		if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('Buff is related to player', nkLog.levelInfo) end
		buffDetails = Inspect.Buff.Detail('player', buffs)
		
		for k, buff in pairs (buffDetails) do
			if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('found [' .. buff.name .. ']', nkLog.levelInfo) end
		
			local caster = buff.caster
			local casterDetails = Inspect.Unit.Detail(caster)			
	
			if buff.debuff == true or buff.curse == true then			
				if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('curse or debuff on player', nkLog.levelInfo) end
				
				if nkRBSetup.basic.debuffWarning == true then nkRebuff.privateVars.forceUpdate = true end
			
				local debuffCaster = 'NPC'
				
				if casterDetails == nil then
					if nkRBSetup.basic.debugAddon == true then  nkRebuff.privateVars.mainLog:logMessage ('caster details nil', nkLog.levelInfo)	end
				else
					if nkRBSetup.basic.debugAddon == true and casterDetails.player then nkRebuff.privateVars.mainLog:logMessage ('caster details player: ' .. casterDetails.calling, nkLog.levelInfo) end
				end
				
				if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('caster: ' .. debuffCaster, nkLog.levelInfo) end
								
				if casterDetails ~= nil and casterDetails.player == true then debuffCaster = casterDetails.calling end
				
				if nkRBSetup.data.debuff3rd[buff.name] == nil then
					nkRBSetup.data.debuff3rd[buff.name] = { caster = debuffCaster, ability = buff.abilityNew, icon = buff.icon, duration = buff.duration, hidden = false }
					nkRebuff.addAbility('debuff3rd', buff.name, nkRBSetup.basic.newDebuffActive)
				end
			elseif casterDetails ~= nil then -- Buffs wie Ausgeruht filtern
				if nkRBSetup.basic.debugAddon == true then  nkRebuff.privateVars.mainLog:logMessage ('buff on player', nkLog.levelInfo)	end
				nkRebuff.events.processBuff(buff, casterDetails, playerDetails)
			end
		end	
	end
end

function nkRebuff.events.roleChange (units)

	if nkRBSetup.basic.autoRoleSwitch == false then return end	
	
	local player = Inspect.Unit.Detail ('player')
	
	for k, v in pairs (units) do
		local details = Inspect.Unit.Detail(k)
		if details.name == player.name then
			local currentRole = Inspect.TEMPORARY.Role()
			for idx = 1, #nkRBSetup.sets, 1 do
				if nkRBSetup.sets[idx].role == currentRole then
					nkRebuff.activateSet (idx)
					return
				end
			end
		end
	end

end

-- Event sub routines

function nkRebuff.events.trackAbility (abilityType, abilityName, stacks)
	
	if nkRebuff.privateVars.tempHides[abilityType][abilityName] ~= nil then return false end
	
	if abilityType == 'buffTarget' then 
		if nkRBSetup.data.buff[abilityName] == nil then return false end
	elseif nkRBSetup.data[abilityType][abilityName] == nil then return false end
			
	if nkRBSetup.sets[nkRBSetup.basic.activeSet][abilityType][abilityName] ~= nil and nkRBSetup.sets[nkRBSetup.basic.activeSet][abilityType][abilityName].active == true then
		if Inspect.System.Secure() == true or nkRBSetup.sets[nkRBSetup.basic.activeSet][abilityType][abilityName].sco ~= true then
			if stacks == nil then stacks = 1 end

			if nkRBSetup.sets[nkRBSetup.basic.activeSet][abilityType][abilityName].stackType == 0 then
				return true
			elseif nkRBSetup.sets[nkRBSetup.basic.activeSet][abilityType][abilityName].stackType == 1 and stacks >= nkRBSetup.sets[nkRBSetup.basic.activeSet][abilityType][abilityName].stackCount then
				return true
			elseif nkRBSetup.sets[nkRBSetup.basic.activeSet][abilityType][abilityName].stackType == 2 and stacks ~= nkRBSetup.sets[nkRBSetup.basic.activeSet][abilityType][abilityName].stackCount then
				return true
			elseif nkRBSetup.sets[nkRBSetup.basic.activeSet][abilityType][abilityName].stackType == 3 and stacks <= nkRBSetup.sets[nkRBSetup.basic.activeSet][abilityType][abilityName].stackCount then
				return true
			end
		end
	end
	
	return false

end

function nkRebuff.events.processDebuff (buff, casterDetails, playerDetails)

	if casterDetails ~= nil and casterDetails.name == playerDetails.name and buff.abilityNew ~= nil then
		if nkRBSetup.data.debuff[buff.name] == nil then
			nkRBSetup.data.debuff[buff.name] = { ability = buff.abilityNew, icon = buff.icon, duration = buff.duration, hidden = false }
			nkRebuff.addAbility('debuff', buff.name, false)
		end
		nkRebuff.privateVars.forceUpdate = true
	end

end

function nkRebuff.events.processBuff (buff, casterDetails, playerDetails)

	if casterDetails ~= nil then -- Buffs wie Ausgeruht filtern
		local caster = 'player'
		
		if nkRBSetup.basic.debugAddon == true then nkRebuff.privateVars.mainLog:logMessage ('caster: ' .. caster .. ' / ' .. casterDetails.name .. ', ' .. playerDetails.name, nkLog.levelInfo) end
		
		if casterDetails.name ~= playerDetails.name then 
			caster = casterDetails.calling
			if nkRBSetup.data.buff3rd[buff.name] == nil then
				nkRBSetup.data.buff3rd[buff.name] = { caster = caster, ability = buff.abilityNew, icon = buff.icon, duration = buff.duration, hidden = false }
				nkRebuff.addAbility('buff3rd', buff.name, false)
			end
		elseif nkRBSetup.data.buff[buff.name] == nil then
			nkRBSetup.data.buff[buff.name] = { caster = caster, ability = buff.abilityNew, icon = buff.icon, duration = buff.duration, hidden = false }
			nkRebuff.addAbility('buff', buff.name, false)
		end		
	end

end

function nkRebuff.events.checkRemaining (remaining, customRemainingFlag, customRemaining, barRemaining)

	if remaining == nil then return false end

	if nkRBSetup.basic.remainingWarning == true and customRemainingFlag == true and customRemaining ~= nil then
		if remaining <= customRemaining then return true else return false end
	end

	if remaining < barRemaining then return true end
	
	return false

end

function nkRebuff.events.checkBuffsForMissing(buff, name, storedData)

	if buff.active == true and nkRebuff.privateVars.tempHides.buff[name] ~= true then
		if Inspect.System.Secure() == true or buff.sco ~= true then
			
			if nkRebuff.privateVars.tempData.buffs.active[name] == nil then
				if buff.nms ~= true then
					nkRebuff.privateVars.tempData.buffs.missing[name] = storedData
					nkRebuff.privateVars.tempData.buffs.missing[name].stack = nil
					nkRebuff.privateVars.tempData.buffs.missingCount = nkRebuff.privateVars.tempData.buffs.missingCount + 1
				end
			else
				if nkRebuff.privateVars.tempData.buffs.missing[name] ~= nil then
					-- fix recognized player's pets buffs
					nkRebuff.privateVars.tempData.buffs.missing[name] = nil
					nkRebuff.privateVars.tempData.buffs.missingCount = nkRebuff.privateVars.tempData.buffs.missingCount - 1
				end
				
				if buff.nms == true or nkRebuff.events.checkRemaining (nkRebuff.privateVars.tempData.buffs.active[name].remaining, buff.customRemaining, buff.runoutDuration, nkRBSetup.bars[nkRebuff.const.barBuffsID].runoutDuration) == true then
					if buff.nms ~= true and nkRBSetup.basic.remainingWarning == true and buff.dnw ~= true then
						nkRebuff.privateVars.warnItems.items[name] = storedData
						nkRebuff.privateVars.warnItems.items[name].stack = nkRebuff.privateVars.tempData.buffs.active[name].stack
						nkRebuff.privateVars.warnItems.items[name].remaining = nkRebuff.privateVars.tempData.buffs.active[name].remaining
						nkRebuff.privateVars.warnItems.warningCount = nkRebuff.privateVars.warnItems.warningCount + 1										
					else
						nkRebuff.privateVars.tempData.buffs.missing[name] = storedData
						nkRebuff.privateVars.tempData.buffs.missing[name].stack = nkRebuff.privateVars.tempData.buffs.active[name].stack
						nkRebuff.privateVars.tempData.buffs.missingCount = nkRebuff.privateVars.tempData.buffs.missingCount + 1
						nkRebuff.privateVars.tempData.buffs.nearRunoutList[name] = nkRebuff.privateVars.tempData.buffs.active[name].remaining
					end
				elseif buff.stackType > 0 then
					if nkRebuff.privateVars.tempData.buffs.active[name].stack == nil then nkRebuff.privateVars.tempData.buffs.active[name].stack = 1 end
				
					if buff.stackType == 1 and nkRebuff.privateVars.tempData.buffs.active[name].stack < buff.stackCount then
						nkRebuff.privateVars.tempData.buffs.missing[name] = storedData
						nkRebuff.privateVars.tempData.buffs.missing[name].stack = nkRebuff.privateVars.tempData.buffs.active[name].stack
						nkRebuff.privateVars.tempData.buffs.missingCount = nkRebuff.privateVars.tempData.buffs.missingCount + 1
					elseif buff.stackType == 2 and nkRebuff.privateVars.tempData.buffs.active[name].stack == buff.stackCount then
						nkRebuff.privateVars.tempData.buffs.missing[name] = storedData
						nkRebuff.privateVars.tempData.buffs.missing[name].stack = nkRebuff.privateVars.tempData.buffs.active[name].stack
						nkRebuff.privateVars.tempData.buffs.missingCount = nkRebuff.privateVars.tempData.buffs.missingCount + 1
					elseif buff.stackType == 3 and nkRebuff.privateVars.tempData.buffs.active[name].stack > buff.stackCount then
						nkRebuff.privateVars.tempData.buffs.missing[name] = storedData
						nkRebuff.privateVars.tempData.buffs.missing[name].stack = nkRebuff.privateVars.tempData.buffs.active[name].stack
						nkRebuff.privateVars.tempData.buffs.missingCount = nkRebuff.privateVars.tempData.buffs.missingCount + 1
					end
				end
			end
		end
	end
end